package algorithm;

import algorithm.dataStructures.CompactDegreeSequence;
import algorithm.dataStructures.GraphInterface;

public interface ErdosGallaiInterface
{

	/**
	 * 
	 * Computes a lower bound on the number of edges that have to be added in order to realize sol as a super-graph of the graph given in the
	 * constructor
	 * 
	 * @param sol
	 * @param fixAll
	 * @return
	 */
	public int computeFeasibility(CompactDegreeSequence sol, boolean fixAll);

	public int computeFeasibility(CompactDegreeSequence sol, boolean fixAll, boolean getMaxDiff);

	public int computeFeasibility(CompactDegreeSequence sol, boolean fixAll, boolean getMaxDiff, boolean checkPartialSolution);

	public void setGraph(GraphInterface graph, CompactDegreeSequence init);

}
