package algorithm.alternativeRealizer;

import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;

import algorithm.dataStructures.CompactDegreeSequence;

public class BlockRaiseListComputer
{

	public List<RaiseSequenceEntry> generateBlockRaiseListBottomUp(final CompactDegreeSequence initialSeq, final CompactDegreeSequence solutionSeq)
	{
		final int initSeqCopy[] = initialSeq.getDegreeCopy();
		if (initialSeq.getMaxDegree() > solutionSeq.getMaxDegree())
		{
			System.out.println();
		}
		final List<RaiseSequenceEntry> degreeRaiseList = new LinkedList<>();
		for (int i = 0; i < initSeqCopy.length; i++)
		{
			if (initSeqCopy[i] > solutionSeq.get(i))
			{
				final int diff = initSeqCopy[i] - solutionSeq.get(i);
				int j = i + 1;
				while ((j < initSeqCopy.length) && (solutionSeq.get(j) == 0))
				{
					++j;
				}
				degreeRaiseList.add(new RaiseSequenceEntry(i, j, diff));
				if (j < initSeqCopy.length)
				{
					initSeqCopy[j] += diff - Math.max(0, solutionSeq.get(i) - initSeqCopy[i]);
				}

			}

		}
		return degreeRaiseList;
	}

}
