package algorithm.dataStructures;

/**
 * An edge in an undirected adjacent graph.
 * 
 * @author clemens
 * 
 */
public class Edge
{

	private final int vertexA;

	private final int vertexB;

	/**
	 * Constructs a new undirected edge. The order in which the vertices are entered is irrelevant.
	 * 
	 * @param vertexA First vertex of the edge.
	 * @param vertexB Second vertex of the edge.
	 */
	public Edge(final int vertexA, final int vertexB)
	{
		super();
		this.vertexA = vertexA;
		this.vertexB = vertexB;
	}

	public int getVertexA()
	{
		return this.vertexA;
	}

	public int getVertexB()
	{
		return this.vertexB;
	}

}
