package algorithm.dataStructures;

public class Timer
{

	private final double maxTime;
	private final long timeStamp;

	public Timer()
	{
		this(-1);
	}

	public Timer(final int maxTimeBound)
	{
		this.maxTime = maxTimeBound;
		this.timeStamp = System.currentTimeMillis();
	}

	public double elapsedTimeInSeconds()
	{
		return (System.currentTimeMillis() - this.timeStamp) / 1000d;
	}

	public int getRemainingTime()
	{
		if (this.maxTime < 0d)
			throw new IllegalAccessError("max time was not set");
		return (int) Math.floor(this.maxTime - this.elapsedTimeInSeconds());
	}

	public boolean isMaxTimeSet()
	{
		return this.maxTime >= 0d;
	}
}
