package algorithm.graphRealizer;

import java.util.HashSet;
import java.util.Vector;

import dataStructures.IntTupel;

abstract class AbstractEdgeContainer
{
	static AbstractEdgeContainer getHashSetBasedEdgeContainer()
	{
		class T extends AbstractEdgeContainer
		{
			private final HashSet<IntTupel> set = new HashSet<>();

			@Override
			void addAll(final HashSet<IntTupel> addEdges)
			{
				this.set.addAll(addEdges);
			}

			@Override
			void addEdges(final IntTupel intTupel)
			{
				this.set.add(intTupel);
			}

			@Override
			boolean contains(final IntTupel intTupel)
			{
				return this.set.contains(intTupel);
			}

			@Override
			Iterable<IntTupel> getAllEdges()
			{
				return this.set;
			}

			@Override
			void remove(final IntTupel tup)
			{
				this.set.remove(tup);
			}

			@Override
			void removeAll(final Vector<IntTupel> removeEdges)
			{
				this.set.removeAll(removeEdges);
			}

		}
		return new T();
	}

	void addAll(final HashSet<IntTupel> addEdges)
	{
		for (final IntTupel tup : addEdges)
		{
			this.addEdges(tup);
		}
	}

	abstract void addEdges(IntTupel intTupel);

	abstract boolean contains(IntTupel intTupel);

	abstract Iterable<IntTupel> getAllEdges();

	abstract void remove(IntTupel tup);

	void removeAll(final Vector<IntTupel> removeEdges)
	{
		for (final IntTupel tup : removeEdges)
		{
			this.remove(tup);
		}
	}

}
