package algorithm.graphRealizer;

import dataStructures.IntTupel;
import distanceFunction.SymmetricSparseBitSetDistanceFunction;

class BitSetBasedEdgeContainer extends AbstractEdgeContainer
{
	private final SymmetricSparseBitSetDistanceFunction sym;

	public BitSetBasedEdgeContainer(final int n)
	{
		this.sym = new SymmetricSparseBitSetDistanceFunction(n);
	}

	@Override
	public void addEdges(final IntTupel intTupel)
	{
		this.sym.set(intTupel.getFirst(), intTupel.getSecond(), true);
	}

	@Override
	public boolean contains(final IntTupel intTupel)
	{
		return this.sym.get(intTupel.getFirst(), intTupel.getSecond());
	}

	@Override
	public Iterable<IntTupel> getAllEdges()
	{
		return this.sym.getIndicesWithSetValue();

	}

	@Override
	public void remove(final IntTupel tup)
	{
		this.sym.set(tup.getFirst(), tup.getSecond(), false);
	}

}