package benchmarks;

import progOpt.MainFastUpperBoundHeuristic;
import progOpt.MainMoreSophisticatedUpperBoundHeuristic;
import algorithm.UpperBound;
import algorithm.dataStructures.GraphInterface;

public class TestHeuristic extends Thread
{
	private final GraphInterface graph;

	private final int k;

	public TestHeuristic(final GraphInterface graph, final int k)
	{
		this.graph = graph;
		this.k = k;
	}

	@Override
	public void run()
	{
		LogStringBuilder.getLogger().startTime();
		LogStringBuilder.getLogger().addEntry(LogStringBuilder.LogKey_KOLJA_HEURISTIC,
				UpperBound.getClusteringHeuristicUpperBound(this.k, this.graph), true);
		boolean verbose = false;
		final int maxTime = 60 * 5;

		MainFastUpperBoundHeuristic.setOptimizedParametersForFastUpperBound(maxTime, verbose);
		LogStringBuilder.getLogger().addEntry(LogStringBuilder.LogKey_FAST_UPPERBOUND_HEURISTIC,
				UpperBound.getFastUpperBoundForKAnonAndRealizable(this.graph, this.k, maxTime), true);
		
		MainMoreSophisticatedUpperBoundHeuristic.setOptimizedParametersForMoreSophisticatedUpperBound(maxTime, verbose);
		LogStringBuilder.getLogger().addEntry(LogStringBuilder.LogKey_SEMI_SOPHISTICATED_UPPERBOUND_HEURISTIC,
				UpperBound.getSophisticatedUpperBoundForKAnonAndRealizable(this.graph, this.k, maxTime).getS1(), true);
		

		LogStringBuilder.getLogger().addEntry(LogStringBuilder.LogKey_SOPHISTICATED_UPPERBOUND_HEURISTIC,
				UpperBound.getMoreSophisticatedUpperBoundForKAnonAndRealizable(this.graph, this.k, maxTime).getS1(), true);
	}
}
