package benchmarks;

import gnu.trove.set.TIntSet;
import gnu.trove.set.hash.TIntHashSet;

import java.util.ArrayList;
import java.util.List;

import algorithm.DegreeAnonymizer;
import algorithm.dataStructures.AdjacentGraph;
import algorithm.dataStructures.GraphInterface;

public class TestforKolja
{
	public static void addEdge(final List<TIntSet> adjacentList, final int a, final int b)
	{
		adjacentList.get(a).add(b);
		adjacentList.get(b).add(a);
	}

	public static GraphInterface getGraph()
	{
		final List<TIntSet> adjacentList = new ArrayList<>();

		for (int i = 1; i <= 26; i++)
		{
			adjacentList.add(new TIntHashSet());
		}

		for (int i = 1; i <= 9; i++)
		{
			TestforKolja.addEdge(adjacentList, i, 26);
		}

		for (int i = 10; i <= 13; i++)
		{
			TestforKolja.addEdge(adjacentList, i, 24);
		}
		for (int i = 14; i <= 17; i++)
		{
			TestforKolja.addEdge(adjacentList, i, 25);
		}

		TestforKolja.addEdge(adjacentList, 18, 19);
		TestforKolja.addEdge(adjacentList, 18, 20);
		TestforKolja.addEdge(adjacentList, 19, 20);

		TestforKolja.addEdge(adjacentList, 18, 21);
		TestforKolja.addEdge(adjacentList, 19, 22);
		TestforKolja.addEdge(adjacentList, 20, 23);

		TestforKolja.addEdge(adjacentList, 21, 23);
		TestforKolja.addEdge(adjacentList, 22, 23);

		TestforKolja.addEdge(adjacentList, 21, 24);
		TestforKolja.addEdge(adjacentList, 21, 25);
		TestforKolja.addEdge(adjacentList, 22, 24);
		TestforKolja.addEdge(adjacentList, 22, 25);
		TestforKolja.addEdge(adjacentList, 23, 24);
		TestforKolja.addEdge(adjacentList, 23, 25);

		// addEdge(adjacentList,24,25);

		final GraphInterface graph = new AdjacentGraph(adjacentList);
		return graph;
	}

	public static GraphInterface getGraph2()
	{
		final List<TIntSet> adjacentList = new ArrayList<>();

		for (int i = 1; i <= 3; i++)
		{
			adjacentList.add(new TIntHashSet());
		}
		TestforKolja.addEdge(adjacentList, 1, 2);

		final GraphInterface graph = new AdjacentGraph(adjacentList);
		return graph;
	}

	public static GraphInterface getGraph3()
	{
		final List<TIntSet> adjacentList = new ArrayList<>();

		for (int i = 1; i <= 7; i++)
		{
			adjacentList.add(new TIntHashSet());
		}
		TestforKolja.addEdge(adjacentList, 2, 6);
		TestforKolja.addEdge(adjacentList, 3, 7);
		TestforKolja.addEdge(adjacentList, 3, 4);
		TestforKolja.addEdge(adjacentList, 1, 5);

		final GraphInterface graph = new AdjacentGraph(adjacentList);
		return graph;
	}

	public static void main(final String[] args)
	{
		final GraphInterface graph = TestforKolja.getGraph();
		// final Reader reader = new Reader("n_0015_nr_2942.txt");
		// final GraphInterface graph = reader.readInputGraphAlternateFormat();

		final FKDA fkda = new FKDA();
		// result as Set<IntTupel> (kanten welche hinzugefügt werden, falls
		// nicht möglich
		// CannotRealize exception)
		int minSolutionToAnonymizeNumbers;
		int res;
		// res = fkda.fkda(graph, 2).size();
		// System.out.println(res);
		for (int k = 1; k < 25; k++)
		{
			System.out.println("k: " + k);
			minSolutionToAnonymizeNumbers = new DegreeAnonymizer(graph, k).getSizeOfMinimumSolution();
			// minSolutionToAnonymizeNumbers = 0; // (int) (0.5 *
			// minSolutionToAnonymizeNumbers);
			// // convert degree changes in
			// no of edges
			minSolutionToAnonymizeNumbers /= 2;
			System.out.println("min solution: " + minSolutionToAnonymizeNumbers);
			res = fkda.fkda(graph, k, FKDA.Heuristic.RANDOM).size();
			// gibt die Moeglichkeit via fkda.set_trials(t); die Anzahl der
			// Versuche fuer die RANDOM Heuristik zu setzen (default = #Knoten)
			System.out.println("fdka solution: " + res);
			if (minSolutionToAnonymizeNumbers > res)
			{
				System.out.println("bei k: " + k + " fkda kleinere loesung");
			}
			System.out.println("-------");
		}

	}

}
