package progOpt;

import java.text.DecimalFormat;
import java.util.Arrays;

import org.apache.commons.lang3.ArrayUtils;

import dataStructures.utils.ArrayS;

public class LogScaleForParamILS
{

	public static void main(final String[] args)
	{

		final double[] bounds = { 2, 20, 1000 };
		final double midValue = bounds[1];
		final double maxValue = bounds[2];
		final double minValue = bounds[0];
		final int numberOfSteps = 8;
		LogScaleForParamILS.printLogScaleArray(midValue, maxValue, minValue, numberOfSteps);
	}

	public static void printLogScaleArray(final double midValue, final double maxValue, final double minValue, final int numberOfSteps)
	{
		final DecimalFormat formater = new DecimalFormat(((maxValue - minValue) / numberOfSteps) < 3 ? "0.0#" : "0");
		final double base = Math.exp(Math.log((maxValue - midValue) + 1) / (LogScaleForParamILS.stepFunc(numberOfSteps, maxValue - minValue)));
		// System.out.println("base:" + base);

		final double[] greaterArr = new double[numberOfSteps];
		double[] smallerArr = new double[numberOfSteps];
		Arrays.fill(smallerArr, minValue - 1);
		final double[] diff = new double[numberOfSteps - 1];
		// System.out.println();

		boolean flag = true;
		for (int i = 1; i <= numberOfSteps; i++)
		{
			final double pow = (midValue - 1) + Math.pow(base, LogScaleForParamILS.stepFunc(i, maxValue - minValue));
			greaterArr[i - 1] = pow;
			if (flag)
			{
				smallerArr[numberOfSteps - i] = midValue - (pow - midValue);
				if (smallerArr[numberOfSteps - i] < minValue)
				{
					flag = false;
					if ((i > 1) && (Double.parseDouble(formater.format(smallerArr[(numberOfSteps - i) + 1])) > minValue))
					{
						smallerArr[numberOfSteps - i] = minValue;
						smallerArr = Arrays.copyOfRange(smallerArr, numberOfSteps - i, numberOfSteps);
					} else
					{
						smallerArr = Arrays.copyOfRange(smallerArr, (numberOfSteps - i) + 1, numberOfSteps);
					}
				}
			}
			if ((i - 2) >= 0)
			{
				diff[i - 2] = greaterArr[i - 1] - greaterArr[i - 2];
			}
		}
		System.out.println("{" + ArrayS.toString(ArrayUtils.toObject(smallerArr), ",", formater) + "," + formater.format(midValue) + ","
				+ ArrayS.toString(ArrayUtils.toObject(greaterArr), ",", formater) + "}");
		// System.out.println();
		System.out.println(ArrayS.toString(ArrayUtils.toObject(diff), ",", formater));
		System.out.println((greaterArr.length + 1 + smallerArr.length));
	}

	private static double stepFunc(final int numberOfSteps, final double minValue)
	{
		return Math.pow(numberOfSteps, minValue > 10 ? 0.7 : 1.4);
	}
}
