package progOpt;

import reader.GraphReader;
import algorithm.UpperBound;
import algorithm.dataStructures.GraphInterface;
import algorithm.dataStructures.Timer;

public class MainSophisticatedUpperBoundHeuristic
{
	public static void main(final String[] args)
	{
		final Timer timer = new Timer();
		final boolean verbose = false;
		final StringBuilder fileNameB = new StringBuilder();

		MainFastUpperBoundHeuristic.setAndReadCommandLineParameters(args, verbose, fileNameB, true, false, true, false);

		String filePath = fileNameB.toString();
		final int k = ComputeFeatureSetFile.parseKValueFromFileString(filePath);
		filePath = ComputeFeatureSetFile.eraseKValueFromFileString(filePath);
		System.out.println(filePath);
		System.out.println("k=" + k);
		filePath = MainFastUpperBoundHeuristic.replaceGraphFolderString(filePath);

		final GraphInterface graph = new GraphReader(filePath).readGraphFile();

		final long startTimeStamp = System.currentTimeMillis();

		// System.out.println("clustering heuristik:" +
		// UpperBound.getClusteringHeuristicUpperBound(k, graph) + "("
		// + (System.currentTimeMillis() - startTimeStamp) / 1000d + ")");
		// startTimeStamp = System.currentTimeMillis();

		// DegreeAnonymizer2.logDR = 1;
		// UpperBound.printRealizerParams = true;
		// // GraphRealizer.log = 1;
		final int maxTime = (int) Math.floor(MainFastUpperBoundHeuristic.Safety_Buffer_Fac_Max_Time_Realizer.doubleValue()
				* (MainFastUpperBoundHeuristic.cutoff_time.doubleValue() - timer.elapsedTimeInSeconds()));
		final int upperBound = UpperBound.getSophisticatedUpperBoundForKAnonAndRealizable(graph, k, maxTime).getS1();
		System.out.println("upperbound:" + upperBound);
		System.out.flush();

		final double time = (System.currentTimeMillis() - startTimeStamp) / 1000d;
		System.out.println("heuristic time:" + time);
		System.out.println("total time:" + timer.elapsedTimeInSeconds());
		System.out.flush();
	}
}
